fips-check.sh 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449
  1. #!/bin/bash
  2. # fips-check.sh
  3. # This script checks the current revision of the code against the
  4. # previous release of the FIPS code. While wolfSSL and wolfCrypt
  5. # may be advancing, they must work correctly with the last tested
  6. # copy of our FIPS approved code.
  7. #
  8. # This should check out all the approved flavors. The command line
  9. # option selects the flavor.
  10. #
  11. # $ ./fips-check [flavor] [keep]
  12. #
  13. # - flavor: linux (default), ios, android, windows, freertos, linux-ecc, netbsd-selftest, linuxv2, fips-ready, stm32l4-v2, linuxv5, linuxv5-ready, linuxv5-dev
  14. #
  15. # - keep: (default off) XXX-fips-test temp dir around for inspection
  16. #
  17. Usage() {
  18. cat <<usageText
  19. Usage: $0 [flavor [keep]]
  20. Flavor is one of:
  21. linux (default)
  22. ios
  23. android
  24. windows
  25. freertos
  26. openrtos-3.9.2
  27. linux-ecc
  28. netbsd-selftest
  29. marvell-linux-selftest
  30. sgx
  31. netos-7.6
  32. linuxv2 (FIPSv2, use for Win10)
  33. fips-ready
  34. stm32l4-v2 (FIPSv2, use for STM32L4)
  35. wolfrand
  36. solaris
  37. linuxv5 (current FIPS 140-3)
  38. linuxv5-ready (ready FIPS 140-3)
  39. linuxv5-dev (dev FIPS 140-3)
  40. Keep (default off) retains the XXX-fips-test temp dir for inspection.
  41. Example:
  42. $0 windows keep
  43. usageText
  44. }
  45. MAKE='make'
  46. LINUX_FIPS_VERSION=v3.2.6
  47. LINUX_FIPS_REPO=git@github.com:wolfSSL/fips.git
  48. LINUX_CRYPT_VERSION=v3.2.6
  49. LINUX_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  50. LINUX_ECC_FIPS_VERSION=v3.10.3
  51. LINUX_ECC_FIPS_REPO=git@github.com:wolfSSL/fips.git
  52. LINUX_ECC_CRYPT_VERSION=v3.2.6
  53. LINUX_ECC_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  54. IOS_FIPS_VERSION=v3.4.8a
  55. IOS_FIPS_REPO=git@github.com:wolfSSL/fips.git
  56. IOS_CRYPT_VERSION=v3.4.8.fips
  57. IOS_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  58. ANDROID_FIPS_VERSION=v3.5.0
  59. ANDROID_FIPS_REPO=git@github.com:wolfSSL/fips.git
  60. ANDROID_CRYPT_VERSION=v3.5.0
  61. ANDROID_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  62. WINDOWS_FIPS_VERSION=v3.6.6
  63. WINDOWS_FIPS_REPO=git@github.com:wolfSSL/fips.git
  64. WINDOWS_CRYPT_VERSION=v3.6.6
  65. WINDOWS_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  66. FREERTOS_FIPS_VERSION=v3.6.1-FreeRTOS
  67. FREERTOS_FIPS_REPO=git@github.com:wolfSSL/fips.git
  68. FREERTOS_CRYPT_VERSION=v3.6.1
  69. FREERTOS_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  70. OPENRTOS_3_9_2_FIPS_VERSION=v3.9.2-OpenRTOS
  71. OPENRTOS_3_9_2_FIPS_REPO=git@github.com:wolfSSL/fips.git
  72. OPENRTOS_3_9_2_CRYPT_VERSION=v3.6.1
  73. OPENRTOS_3_9_2_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  74. #NOTE: Does not include the SGX examples yet, update version once fipsv2 is
  75. # finished and merge conflicts can be resolved. This will be tagged as
  76. # v3.12.4.sgx-examples
  77. #SGX_FIPS_VERSION=v3.12.4.sgx-examples
  78. SGX_FIPS_VERSION=v3.6.6
  79. SGX_FIPS_REPO=git@github.com:wolfSSL/fips.git
  80. SGX_CRYPT_VERSION=v3.12.4
  81. SGX_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  82. NETOS_7_6_FIPS_VERSION=v3.12.6
  83. NETOS_7_6_FIPS_REPO=git@github.com:wolfSSL/fips.git
  84. NETOS_7_6_CRYPT_VERSION=v3.12.4
  85. NETOS_7_6_CRYPT_REPO=git@github.com:cyassl/cyassl.git
  86. # non-FIPS, CAVP only but pull in selftest
  87. # will reset above variables below in flavor switch
  88. NETBSD_FIPS_VERSION=v3.14.2b
  89. NETBSD_FIPS_REPO=git@github.com:wolfssl/fips.git
  90. NETBSD_CRYPT_VERSION=v3.14.2
  91. NETBSD_CRYPT_REPO=git@github.com:wolfssl/wolfssl.git
  92. # non-FIPS, CAVP only but pull in selftest
  93. # will reset above variables below in flavor switch
  94. MARVELL_LINUX_FIPS_VERSION=v3.14.2b
  95. MARVELL_LINUX_FIPS_REPO=git@github.com:wolfssl/fips.git
  96. MARVELL_LINUX_CRYPT_VERSION=v4.1.0-stable
  97. MARVELL_LINUX_CRYPT_REPO=git@github.com:wolfssl/wolfssl.git
  98. STM32L4_V2_FIPS_VERSION=WCv4.0.1-stable
  99. STM32L4_V2_FIPS_REPO=git@github.com:wolfSSL/fips.git
  100. STM32L4_V2_CRYPT_VERSION=WCv4.0.1-stable
  101. FIPS_SRCS=( fips.c fips_test.c )
  102. WC_MODS=( aes des3 sha sha256 sha512 rsa hmac random )
  103. TEST_DIR=XXX-fips-test
  104. CRYPT_INC_PATH=cyassl/ctaocrypt
  105. CRYPT_SRC_PATH=ctaocrypt/src
  106. RNG_VERSION=v3.6.0
  107. FIPS_OPTION=v1
  108. CAVP_SELFTEST_ONLY="no"
  109. GIT="git -c advice.detachedHead=false"
  110. if [ "$1" == "" ]; then FLAVOR="linux"; else FLAVOR="$1"; fi
  111. if [ "$2" == "keep" ]; then KEEP="yes"; else KEEP="no"; fi
  112. case "$FLAVOR" in
  113. ios)
  114. FIPS_VERSION=$IOS_FIPS_VERSION
  115. FIPS_REPO=$IOS_FIPS_REPO
  116. CRYPT_VERSION=$IOS_CRYPT_VERSION
  117. CRYPT_REPO=$IOS_CRYPT_REPO
  118. ;;
  119. android)
  120. FIPS_VERSION=$ANDROID_FIPS_VERSION
  121. FIPS_REPO=$ANDROID_FIPS_REPO
  122. CRYPT_VERSION=$ANDROID_CRYPT_VERSION
  123. CRYPT_REPO=$ANDROID_CRYPT_REPO
  124. ;;
  125. windows)
  126. FIPS_VERSION=$WINDOWS_FIPS_VERSION
  127. FIPS_REPO=$WINDOWS_FIPS_REPO
  128. CRYPT_VERSION=$WINDOWS_CRYPT_VERSION
  129. CRYPT_REPO=$WINDOWS_CRYPT_REPO
  130. ;;
  131. freertos)
  132. FIPS_VERSION=$FREERTOS_FIPS_VERSION
  133. FIPS_REPO=$FREERTOS_FIPS_REPO
  134. CRYPT_VERSION=$FREERTOS_CRYPT_VERSION
  135. CRYPT_REPO=$FREERTOS_CRYPT_REPO
  136. ;;
  137. openrtos-3.9.2)
  138. FIPS_VERSION=$OPENRTOS_3_9_2_FIPS_VERSION
  139. FIPS_REPO=$OPENRTOS_3_9_2_FIPS_REPO
  140. CRYPT_VERSION=$OPENRTOS_3_9_2_CRYPT_VERSION
  141. CRYPT_REPO=$OPENRTOS_3_9_2_CRYPT_REPO
  142. FIPS_CONFLICTS=( aes hmac random sha256 )
  143. ;;
  144. linux)
  145. FIPS_VERSION=$LINUX_FIPS_VERSION
  146. FIPS_REPO=$LINUX_FIPS_REPO
  147. CRYPT_VERSION=$LINUX_CRYPT_VERSION
  148. CRYPT_REPO=$LINUX_CRYPT_REPO
  149. ;;
  150. linux-ecc)
  151. FIPS_VERSION=$LINUX_ECC_FIPS_VERSION
  152. FIPS_REPO=$LINUX_ECC_FIPS_REPO
  153. CRYPT_VERSION=$LINUX_ECC_CRYPT_VERSION
  154. CRYPT_REPO=$LINUX_ECC_CRYPT_REPO
  155. ;;
  156. linuxv2)
  157. FIPS_VERSION=WCv4-stable
  158. FIPS_REPO=git@github.com:wolfssl/fips.git
  159. CRYPT_VERSION=WCv4-stable
  160. CRYPT_INC_PATH=wolfssl/wolfcrypt
  161. CRYPT_SRC_PATH=wolfcrypt/src
  162. WC_MODS+=( cmac dh ecc sha3 )
  163. RNG_VERSION=WCv4-rng-stable
  164. FIPS_SRCS+=( wolfcrypt_first.c wolfcrypt_last.c )
  165. FIPS_INCS=( fips.h )
  166. FIPS_OPTION=v2
  167. ;;
  168. netbsd-selftest)
  169. FIPS_VERSION=$NETBSD_FIPS_VERSION
  170. FIPS_REPO=$NETBSD_FIPS_REPO
  171. CRYPT_VERSION=$NETBSD_CRYPT_VERSION
  172. CRYPT_REPO=$NETBSD_CRYPT_REPO
  173. FIPS_SRCS=( selftest.c )
  174. WC_MODS=( dh ecc rsa dsa aes sha sha256 sha512 hmac random )
  175. CRYPT_INC_PATH=wolfssl/wolfcrypt
  176. CRYPT_SRC_PATH=wolfcrypt/src
  177. CAVP_SELFTEST_ONLY="yes"
  178. ;;
  179. marvell-linux-selftest)
  180. FIPS_VERSION=$MARVELL_LINUX_FIPS_VERSION
  181. FIPS_REPO=$MARVELL_LINUX_FIPS_REPO
  182. CRYPT_VERSION=$MARVELL_LINUX_CRYPT_VERSION
  183. CRYPT_REPO=$MARVELL_LINUX_CRYPT_REPO
  184. FIPS_SRCS=( selftest.c )
  185. WC_MODS=( dh ecc rsa dsa aes sha sha256 sha512 hmac random )
  186. CRYPT_INC_PATH=wolfssl/wolfcrypt
  187. CRYPT_SRC_PATH=wolfcrypt/src
  188. CAVP_SELFTEST_ONLY="yes"
  189. CAVP_SELFTEST_OPTION=v2
  190. ;;
  191. sgx)
  192. FIPS_VERSION=$SGX_FIPS_VERSION
  193. FIPS_REPO=$SGX_FIPS_REPO
  194. CRYPT_VERSION=$SGX_CRYPT_VERSION
  195. CRYPT_REPO=$SGX_CRYPT_REPO
  196. ;;
  197. netos-7.6)
  198. FIPS_VERSION=$NETOS_7_6_FIPS_VERSION
  199. FIPS_REPO=$NETOS_7_6_FIPS_REPO
  200. CRYPT_VERSION=$NETOS_7_6_CRYPT_VERSION
  201. CRYPT_REPO=$NETOS_7_6_CRYPT_REPO
  202. ;;
  203. linuxv5)
  204. FIPS_REPO="git@github.com:wolfSSL/fips.git"
  205. FIPS_VERSION="WCv5.0-RC12"
  206. CRYPT_REPO="git@github.com:wolfSSL/wolfssl.git"
  207. CRYPT_VERSION="WCv5.0-RC12"
  208. CRYPT_INC_PATH="wolfssl/wolfcrypt"
  209. CRYPT_SRC_PATH="wolfcrypt/src"
  210. WC_MODS=( aes sha sha256 sha512 rsa hmac random cmac dh ecc sha3 kdf )
  211. RNG_VERSION="WCv5.0-RC12"
  212. FIPS_SRCS=( fips.c fips_test.c wolfcrypt_first.c wolfcrypt_last.c )
  213. FIPS_INCS=( fips.h )
  214. FIPS_OPTION="v5-RC12"
  215. COPY_DIRECT=( wolfcrypt/src/aes_asm.S wolfcrypt/src/aes_asm.asm
  216. wolfcrypt/src/sha256_asm.S wolfcrypt/src/sha512_asm.S )
  217. ;;
  218. linuxv5-ready|fips-ready|fips-v5-ready)
  219. FIPS_REPO="git@github.com:wolfSSL/fips.git"
  220. FIPS_VERSION="WCv5.0-RC12"
  221. CRYPT_INC_PATH=wolfssl/wolfcrypt
  222. CRYPT_SRC_PATH=wolfcrypt/src
  223. FIPS_SRCS=( fips.c fips_test.c wolfcrypt_first.c wolfcrypt_last.c )
  224. FIPS_INCS=( fips.h )
  225. FIPS_OPTION=v5-ready
  226. ;;
  227. linuxv5-dev|fips-dev)
  228. FIPS_REPO="git@github.com:wolfSSL/fips.git"
  229. FIPS_VERSION="master"
  230. CRYPT_INC_PATH=wolfssl/wolfcrypt
  231. CRYPT_SRC_PATH=wolfcrypt/src
  232. FIPS_SRCS+=( wolfcrypt_first.c wolfcrypt_last.c )
  233. FIPS_INCS=( fips.h )
  234. FIPS_OPTION=v5-dev
  235. ;;
  236. stm32l4-v2)
  237. FIPS_VERSION=$STM32L4_V2_FIPS_VERSION
  238. FIPS_REPO=$STM32L4_V2_FIPS_REPO
  239. CRYPT_VERSION=$STM32L4_V2_CRYPT_VERSION
  240. CRYPT_INC_PATH=wolfssl/wolfcrypt
  241. CRYPT_SRC_PATH=wolfcrypt/src
  242. # Replace the WC_MODS list for now. Do not want to copy over random.c yet.
  243. WC_MODS=( aes des3 sha sha256 sha512 rsa hmac )
  244. WC_MODS+=( cmac dh ecc )
  245. FIPS_SRCS+=( wolfcrypt_first.c wolfcrypt_last.c )
  246. FIPS_INCS=( fips.h )
  247. FIPS_OPTION=v2
  248. ;;
  249. wolfrand)
  250. FIPS_REPO=git@github.com:wolfssl/fips.git
  251. FIPS_VERSION=WRv4-stable
  252. CRYPT_REPO=git@github.com:wolfssl/wolfssl.git
  253. CRYPT_VERSION=WCv4-stable
  254. CRYPT_INC_PATH=wolfssl/wolfcrypt
  255. CRYPT_SRC_PATH=wolfcrypt/src
  256. RNG_VERSION=WCv4-rng-stable
  257. WC_MODS=( hmac sha256 random )
  258. FIPS_SRCS+=( wolfcrypt_first.c wolfcrypt_last.c )
  259. FIPS_INCS=( fips.h )
  260. FIPS_OPTION=rand
  261. ;;
  262. solaris)
  263. FIPS_VERSION=WCv4-stable
  264. FIPS_REPO=git@github.com:wolfssl/fips.git
  265. CRYPT_VERSION=WCv4-stable
  266. CRYPT_INC_PATH=wolfssl/wolfcrypt
  267. CRYPT_SRC_PATH=wolfcrypt/src
  268. WC_MODS+=( cmac dh ecc sha3 )
  269. RNG_VERSION=WCv4-rng-stable
  270. FIPS_SRCS+=( wolfcrypt_first.c wolfcrypt_last.c )
  271. FIPS_INCS=( fips.h )
  272. FIPS_OPTION=v2
  273. MAKE=gmake
  274. ;;
  275. *)
  276. Usage
  277. exit 1
  278. esac
  279. if ! $GIT clone . "$TEST_DIR"; then
  280. echo "fips-check: Couldn't duplicate current working directory."
  281. exit 1
  282. fi
  283. pushd "$TEST_DIR" || exit 2
  284. case "$FIPS_OPTION" in
  285. *dev)
  286. echo "Don't need to copy in tagged wolfCrypt files for fips-dev."
  287. ;;
  288. *ready)
  289. echo "Don't need to copy in tagged wolfCrypt files for FIPS Ready."
  290. ;;
  291. v1)
  292. # make a clone of the last FIPS release tag
  293. if ! $GIT clone --depth 1 -b "$CRYPT_VERSION" "$CRYPT_REPO" old-tree; then
  294. echo "fips-check: Couldn't checkout the FIPS release."
  295. exit 1
  296. fi
  297. for MOD in "${WC_MODS[@]}"
  298. do
  299. cp "old-tree/$CRYPT_SRC_PATH/${MOD}.c" "$CRYPT_SRC_PATH"
  300. cp "old-tree/$CRYPT_INC_PATH/${MOD}.h" "$CRYPT_INC_PATH"
  301. done
  302. # We are using random.c from a separate release.
  303. # This is forcefully overwriting any other checkout of the cyassl sources.
  304. # Removing this as default behavior for SGX and netos projects.
  305. if [ "$CAVP_SELFTEST_ONLY" == "no" ] && [ "$FLAVOR" != "sgx" ] && \
  306. [ "$FLAVOR" != "netos-7.6" ];
  307. then
  308. pushd old-tree || exit 2
  309. $GIT fetch origin "$RNG_VERSION" || exit $?
  310. $GIT checkout FETCH_HEAD || exit $?
  311. popd || exit 2
  312. cp "old-tree/$CRYPT_SRC_PATH/random.c" "$CRYPT_SRC_PATH"
  313. cp "old-tree/$CRYPT_INC_PATH/random.h" "$CRYPT_INC_PATH"
  314. fi
  315. ;;
  316. v2|rand|v5*)
  317. $GIT branch --no-track "my$CRYPT_VERSION" "$CRYPT_VERSION" || exit $?
  318. # Checkout the fips versions of the wolfCrypt files from the repo.
  319. for MOD in "${WC_MODS[@]}"
  320. do
  321. $GIT checkout "my$CRYPT_VERSION" -- "$CRYPT_SRC_PATH/$MOD.c" "$CRYPT_INC_PATH/$MOD.h" || exit $?
  322. done
  323. for MOD in "${COPY_DIRECT[@]}"
  324. do
  325. $GIT checkout "my$CRYPT_VERSION" -- "$MOD" || exit $?
  326. done
  327. $GIT branch --no-track "myrng$RNG_VERSION" "$RNG_VERSION" || exit $?
  328. # Checkout the fips versions of the wolfCrypt files from the repo.
  329. $GIT checkout "myrng$RNG_VERSION" -- "$CRYPT_SRC_PATH/random.c" "$CRYPT_INC_PATH/random.h" || exit $?
  330. ;;
  331. *)
  332. echo "fips-check: Invalid FIPS option \"${FIPS_OPTION}\"."
  333. exit 1
  334. ;;
  335. esac
  336. # clone the FIPS repository
  337. case "$FIPS_OPTION" in
  338. *dev)
  339. if ! $GIT clone --depth 1 "$FIPS_REPO" fips; then
  340. echo "fips-check: Couldn't check out the FIPS repository for fips-dev."
  341. exit 1
  342. fi
  343. ;;
  344. *)
  345. if ! $GIT clone --depth 1 -b "$FIPS_VERSION" "$FIPS_REPO" fips; then
  346. echo "fips-check: Couldn't check out ${FIPS_VERSION} from repository ${FIPS_REPO}."
  347. exit 1
  348. fi
  349. ;;
  350. esac
  351. for SRC in "${FIPS_SRCS[@]}"
  352. do
  353. cp "fips/$SRC" "$CRYPT_SRC_PATH"
  354. done
  355. for INC in "${FIPS_INCS[@]}"
  356. do
  357. cp "fips/$INC" "$CRYPT_INC_PATH"
  358. done
  359. # run the make test
  360. ./autogen.sh
  361. if [ "$CAVP_SELFTEST_ONLY" == "yes" ];
  362. then
  363. if [ "$CAVP_SELFTEST_OPTION" == "v2" ]
  364. then
  365. ./configure --enable-selftest=v2
  366. else
  367. ./configure --enable-selftest
  368. fi
  369. else
  370. ./configure --enable-fips=$FIPS_OPTION
  371. fi
  372. if ! $MAKE; then
  373. echo "fips-check: Make failed. Debris left for analysis."
  374. exit 3
  375. fi
  376. if [ "$CAVP_SELFTEST_ONLY" == "no" ];
  377. then
  378. NEWHASH=$(./wolfcrypt/test/testwolfcrypt | sed -n 's/hash = \(.*\)/\1/p')
  379. if [ -n "$NEWHASH" ]; then
  380. cp "${CRYPT_SRC_PATH}/fips_test.c" "${CRYPT_SRC_PATH}/fips_test.c.bak"
  381. sed "s/^\".*\";/\"${NEWHASH}\";/" "${CRYPT_SRC_PATH}/fips_test.c.bak" >"${CRYPT_SRC_PATH}/fips_test.c"
  382. make clean
  383. fi
  384. fi
  385. if ! $MAKE test; then
  386. echo "fips-check: Test failed. Debris left for analysis."
  387. exit 3
  388. fi
  389. if [ ${#FIPS_CONFLICTS[@]} -ne 0 ];
  390. then
  391. echo "Due to the way this package is compiled by the customer duplicate"
  392. echo "source file names are an issue, renaming:"
  393. for FNAME in "${FIPS_CONFLICTS[@]}"
  394. do
  395. echo "wolfcrypt/src/$FNAME.c to wolfcrypt/src/wc_$FNAME.c"
  396. mv "./wolfcrypt/src/$FNAME.c" "./wolfcrypt/src/wc_$FNAME.c"
  397. done
  398. echo "Confirming files were renamed..."
  399. ls -la ./wolfcrypt/src/wc_*.c
  400. fi
  401. # Clean up
  402. popd || exit 2
  403. if [ "$KEEP" == "no" ];
  404. then
  405. rm -rf "$TEST_DIR"
  406. fi